//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    5
#property indicator_minimum   -0.1
#property indicator_maximum    1.1
#property indicator_color1     clrGoldenrod
#property indicator_color2     clrLime
#property indicator_color3     clrLime
#property indicator_color4     clrRed
#property indicator_color5     clrRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_level1     1.00
#property indicator_level2     0.00


//
//
//
//
//

extern int                Length            = 30;
extern ENUM_APPLIED_PRICE Price             = PRICE_CLOSE;
extern string             BaseSymbol        = "GBPUSD";
extern double             TresholdUp        = 0.8;
extern double             TresholdDown      = 0.2;
extern int                PreSmooth         = 8;
extern int                PreSmoothPhase    = 0;
extern int                PosSmooth         = 0;
extern int                PosSmoothPhase    = 0;
extern bool               alertsOn          = true;
extern bool               alertsOnZoneEnter = true;
extern bool               alertsOnZoneExit  = true;
extern bool               alertsOnCurrent   = true;
extern bool               alertsMessage     = false;
extern bool               alertsSound       = false;
extern bool               alertsEmail       = false;
extern bool               alertsNotify      = false;

//
//
//
//
//

double stoch[];
double stochua[];
double stochub[];
double stochda[];
double stochdb[];
double stocha[];
double stochb[];
double stochc[];
double pricesa[];
double pricesb[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0, stoch); 
   SetIndexBuffer(1, stochua); 
   SetIndexBuffer(2, stochub); 
   SetIndexBuffer(3, stochda); 
   SetIndexBuffer(4, stochdb); 
   SetIndexBuffer(5, stocha); 
   SetIndexBuffer(6, stochb); 
   SetIndexBuffer(7, stochc); 
   SetIndexBuffer(8, pricesa); 
   SetIndexBuffer(9, pricesb);
   SetIndexBuffer(10,trend); 
      SetLevelValue(2,TresholdUp);
      SetLevelValue(3,TresholdDown);
   IndicatorShortName("ds - divergences "+_Symbol+" to "+BaseSymbol+" ("+Length+")");
   return(0);
}
int deinit()
{
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   double min,max;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   if (trend[limit] ==  1) CleanPoint(limit,stochua,stochub);
   if (trend[limit] == -1) CleanPoint(limit,stochda,stochdb);
   for(i=limit; i>=0; i--)
   {
      pricesa[i] = iSmooth(iMA(NULL      ,0,1,0,MODE_SMA,Price,i),PreSmooth,PreSmoothPhase,i, 0);
      pricesb[i] = iSmooth(iMA(BaseSymbol,0,1,0,MODE_SMA,Price,i),PreSmooth,PreSmoothPhase,i,10);
      
         max = pricesa[ArrayMaximum(pricesa,Length,i)];
         min = pricesa[ArrayMinimum(pricesa,Length,i)];
         if (max!=min)
               stocha[i] = (pricesa[i]-min)/(max-min);
         else  stocha[i] = 0.5;
      
         //
         //
         //
         //
         //
         
         max = pricesb[ArrayMaximum(pricesb,Length,i)];
         min = pricesb[ArrayMinimum(pricesb,Length,i)];
         if (max!=min)
               stochb[i] = (pricesb[i]-min)/(max-min);
         else  stochb[i] = 0.5;

         //
         //
         //
         //
         //
                  
         stochc[i] = stocha[i]-stochb[i];
         max = stochc[ArrayMaximum(stochc,Length*10,i)];
         min = stochc[ArrayMinimum(stochc,Length*10,i)];
         if (max!=min)
               stoch[i] = MathMax(MathMin(iSmooth((stochc[i]-min)/(max-min),PosSmooth,PosSmoothPhase,i,20),1),0);
         else  stoch[i] = MathMax(MathMin(iSmooth(0.5                      ,PosSmooth,PosSmoothPhase,i,20),1),0);
         
         stochua[i] = EMPTY_VALUE;
         stochub[i] = EMPTY_VALUE;
         stochda[i] = EMPTY_VALUE;
         stochdb[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
              if (stoch[i]>TresholdUp)                          trend[i] =  1;
              if (stoch[i]<TresholdDown)                        trend[i] = -1;
              if (stoch[i]<TresholdUp && stoch[i]>TresholdDown) trend[i] =  0;
              if (trend[i] ==  1) PlotPoint(i,stochua,stochub,stoch);
              if (trend[i] == -1) PlotPoint(i,stochda,stochdb,stoch);
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (alertsOnZoneEnter && trend[whichBar]   ==  1) doAlert(whichBar,DoubleToStr(TresholdUp,2)  +" broken up");
         if (alertsOnZoneEnter && trend[whichBar]   == -1) doAlert(whichBar,DoubleToStr(TresholdDown,2)+" broken down");
         if (alertsOnZoneExit  && trend[whichBar+1] == -1) doAlert(whichBar,DoubleToStr(TresholdDown,2)+" broken up");
         if (alertsOnZoneExit  && trend[whichBar+1] ==  1) doAlert(whichBar,DoubleToStr(TresholdUp,2)  +" broken down");
      }
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double wrk[][30];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
              { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else       { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," dual stoch - divergences level  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," dual stoch - divergences level "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

   


